# chdebug start
# Christian Dieterich  Thu Sep 16 06:44:02 CDT 2004
#
# The class Distribution_with_swig implements a Distribution class for
# distutils that runs the build_ext_with_swig class instead of the
# standard build_ext class of distutils.
#
# The class build_ext_with_swig implements a build_ext class for
# distutils that substitutes the functions build_extension and
# swig_sources. The new build_extension creates the build_lib directory
# before running the new swig_sources and that one runs swig with
# include directories and macro definitions. Remember that -U is not
# recognized by swig. swig_sources also copies the Python output of swig
# to the build_lib directory.
#
from distutils.dist import *
class Distribution_with_swig(Distribution):
# chdebug stop

    def get_command_class (self, command):
        """Return the class that implements the Distutils command named by
        'command'.  First we check the 'cmdclass' dictionary; if the
        command is mentioned there, we fetch the class object from the
        dictionary and return it.  Otherwise we load the command module
        ("distutils.command." + command) and fetch the command class from
        the module.  The loaded class is also stored in 'cmdclass'
        to speed future calls to 'get_command_class()'.

        Raises DistutilsModuleError if the expected module could not be
        found, or if that module does not define the expected class.
        """
        klass = self.cmdclass.get(command)
        if klass:
            return klass

        module_name = 'distutils.command.' + command
        klass_name = command
        # chdebug start
        # Christian Dieterich  Thu Sep 16 06:44:02 CDT 2004
        # Substitutes the standard distutils build_ext class
        # with the build_ext_with_swig class
        if klass_name == 'build_ext':
            klass_name = 'build_ext_with_swig'
            module_name = 'build_ext_with_swig'
        # chdebug stop

        try:
            __import__ (module_name)
            module = sys.modules[module_name]
        except ImportError:
            raise DistutilsModuleError, \
                  "invalid command '%s' (no module named '%s')" % \
                  (command, module_name)

        try:
            klass = getattr(module, klass_name)
        except AttributeError:
            raise DistutilsModuleError, \
                  "invalid command '%s' (no class '%s' in module '%s')" \
                  % (command, klass_name, module_name)

        self.cmdclass[command] = klass
        return klass

    # get_command_class ()
